import 'react-draft-wysiwyg/dist/react-draft-wysiwyg.css';
import FieldCoreBase, { IStateFieldBase } from '@react-form-fields/core/components/FieldCoreBase';
import { EditorState } from 'draft-js';
import React from 'react';
import { EditorProps } from 'react-draft-wysiwyg';
import { IBaseFieldProps } from '../../interfaces/props';
declare type PropsResolver = {
    [K in Exclude<keyof EditorProps, keyof IBaseFieldProps>]?: EditorProps[K];
};
interface IState extends IStateFieldBase {
    editorState: EditorState;
    lastValue: string;
    focused: boolean;
}
interface IProps extends IBaseFieldProps, PropsResolver {
    helperText?: React.ReactNode;
    placeholder?: string;
    disabled?: boolean;
}
export default class FieldHtml extends FieldCoreBase<IProps, IState> {
    localization: {
        locale: string;
    };
    defaultToolbar: {
        inline: {
            options: string[];
        };
        list: {
            options: string[];
        };
        embedded: {
            className: any;
        };
        fontSize: {
            className: any;
        };
        blockType: {
            className: any;
        };
        remove: {
            className: any;
        };
        colorPicker: {
            className: any;
        };
        fontFamily: {
            className: any;
        };
        textAlign: {
            className: any;
        };
        emoji: {
            className: any;
        };
    };
    static getDerivedStateFromProps(nextProps: IProps, currentState: IState): IState;
    onChange: (editorState: EditorState) => void;
    onBlur: (e: React.SyntheticEvent<Element, Event>) => void;
    onFocus: () => void;
    handlePastedText: (text: string, html: string) => boolean;
    readonly toolbar: object;
    render(): JSX.Element;
}
export {};
