"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
require("react-draft-wysiwyg/dist/react-draft-wysiwyg.css");
var InputLabel_1 = require("@material-ui/core/InputLabel");
var Typography_1 = require("@material-ui/core/Typography");
var FieldCoreBase_1 = require("@react-form-fields/core/components/FieldCoreBase");
var ValidationContextRegister_1 = require("@react-form-fields/core/components/ValidationContextRegister");
var config_1 = require("@react-form-fields/core/config");
var draft_js_1 = require("draft-js");
var draft_js_import_html_1 = require("draft-js-import-html");
var draftjs_to_html_1 = require("draftjs-to-html");
var html_to_draftjs_1 = require("html-to-draftjs");
var react_1 = require("react");
var react_draft_wysiwyg_1 = require("react-draft-wysiwyg");
var withStyles_1 = require("../../decorators/withStyles");
var styles = require("./style.css");
var FieldHtml = /** @class */ (function (_super) {
    tslib_1.__extends(FieldHtml, _super);
    function FieldHtml() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.localization = { locale: config_1.getConfig().editorLocale };
        _this.defaultToolbar = {
            inline: { options: ['bold', 'italic'] },
            list: { options: ['unordered', 'ordered'] },
            embedded: { className: styles.hide },
            fontSize: { className: styles.hide },
            blockType: { className: styles.hide },
            remove: { className: styles.hide },
            colorPicker: { className: styles.hide },
            fontFamily: { className: styles.hide },
            textAlign: { className: styles.hide },
            emoji: { className: styles.hide }
        };
        _this.onChange = function (editorState) {
            var lastValue = draftjs_to_html_1.default(draft_js_1.convertToRaw(editorState.getCurrentContent())).trim();
            if (lastValue === '<p></p>')
                lastValue = null;
            _this.setState({ editorState: editorState, lastValue: lastValue });
            config_1.getConfig().validationOn === 'onChange' && _this.setState({ showError: true });
            _this.props.onChange(lastValue);
        };
        _this.onBlur = function (e) {
            config_1.getConfig().validationOn === 'onBlur' && _this.setState({ showError: true });
            _this.setState({ focused: false });
            _this.props.onBlur(e);
        };
        _this.onFocus = function () {
            _this.setState({ focused: true });
        };
        _this.handlePastedText = function (text, html) {
            var editorState = _this.state.editorState;
            var blockMap = draft_js_import_html_1.stateFromHTML(html || text).blockMap;
            var newState = draft_js_1.Modifier.replaceWithFragment(editorState.getCurrentContent(), editorState.getSelection(), blockMap);
            _this.onChange(draft_js_1.EditorState.push(editorState, newState, 'insert-fragment'));
            return true;
        };
        return _this;
    }
    FieldHtml.getDerivedStateFromProps = function (nextProps, currentState) {
        var editorState = currentState.editorState, lastValue = currentState.lastValue;
        if (lastValue !== nextProps.value) {
            lastValue = nextProps.value;
            var blocksFromHtml = html_to_draftjs_1.default(lastValue || '');
            var contentBlocks = blocksFromHtml.contentBlocks, entityMap = blocksFromHtml.entityMap;
            editorState = draft_js_1.EditorState.createWithContent(draft_js_1.ContentState.createFromBlockArray(contentBlocks, entityMap));
        }
        return tslib_1.__assign({}, currentState, FieldCoreBase_1.default.getDerivedStateFromProps(nextProps, currentState), { editorState: editorState,
            lastValue: lastValue });
    };
    Object.defineProperty(FieldHtml.prototype, "toolbar", {
        get: function () {
            return this.props.toolbar || config_1.getConfig().editorToolbar || this.defaultToolbar;
        },
        enumerable: true,
        configurable: true
    });
    FieldHtml.prototype.render = function () {
        var _a = this.state, editorState = _a.editorState, focused = _a.focused;
        var _b = this.props, classes = _b.classes, label = _b.label, helperText = _b.helperText, placeholder = _b.placeholder, disabled = _b.disabled, onChange = _b.onChange, onBlur = _b.onBlur, editorProps = tslib_1.__rest(_b, ["classes", "label", "helperText", "placeholder", "disabled", "onChange", "onBlur"]);
        return (react_1.default.createElement("div", { className: "" + styles.component },
            react_1.default.createElement(ValidationContextRegister_1.default, { field: this }),
            react_1.default.createElement("div", { className: classes.label },
                react_1.default.createElement(InputLabel_1.default, { error: !!this.errorMessage, required: this.isRequired, focused: focused }, label),
                helperText || this.errorMessage ?
                    react_1.default.createElement(Typography_1.default, { variant: 'caption', color: this.errorMessage ? 'error' : 'default' }, this.errorMessage || helperText)
                    : null),
            react_1.default.createElement(react_draft_wysiwyg_1.Editor, tslib_1.__assign({}, editorProps, { readonly: disabled, placeholder: placeholder, editorState: editorState, handlePastedText: this.handlePastedText, onFocus: this.onFocus, onBlur: this.onBlur, onEditorStateChange: this.onChange, wrapperClassName: styles.fullWrapper + " " + classes.fullWrapper + " " + (focused ? ' focused ' : '') + " " + (disabled ? ' disabled ' : ''), toolbarClassName: styles.toolbarWrapper + " " + classes.toolbarWrapper, editorClassName: styles.editorWrapper + " " + classes.editorWrapper + " " + (disabled ? ' disabled ' : ''), toolbar: this.toolbar, localization: this.localization }))));
    };
    FieldHtml = tslib_1.__decorate([
        withStyles_1.WithStyles(function (theme) { return ({
            label: {
                display: 'block',
                marginBottom: 5
            },
            fullWrapper: {
                borderColor: theme.palette.type === 'light' ? 'rgba(0, 0, 0, 0.27)' : 'rgba(255, 255, 255, 0.7)',
            },
            editorWrapper: tslib_1.__assign({}, theme.typography.body1)
        }); })
    ], FieldHtml);
    return FieldHtml;
}(FieldCoreBase_1.default));
exports.default = FieldHtml;
//# sourceMappingURL=index.js.map